#include <stdio.h>
#include <unistd.h>
#include "reception.h"

#define BLOQUANT 1
#define NON_BLOQUANT 0

void printbin(unsigned char nombre)
	{
	int i;

	i=7;
	while (i>=0) printf("\033[35;1m%d\033[0m",1&nombre>>i--);
	}

char lectureCaractere(int fd)
	{
	char c;
	read(fd,&c,1);
	return c;
	}

unsigned char * analyse_code(unsigned char* code)
	{
	int position,nouvPos,bit,index;
	unsigned short int echantillon;
	unsigned char *nouvCode;

	nouvCode=(unsigned char*)malloc(65*sizeof(unsigned char));
	memcpy(nouvCode,code,64);

	position=0;
	bit=1<<7;
	while (code[position]&bit)
		{
		bit>>=1;
		if (bit==0)
			{
			bit=1<<7;
			position++;
			}
		}

	index=1<<7;
	nouvPos=0;
	while (position<65)
		{
		if (code[position]&bit)
			{
			nouvCode[nouvPos] |= index;
			}
		else
			{
			nouvCode[nouvPos] &= ~index;
			}
		bit>>=1;
		if (bit==0)
			{
			bit=1<<7;
			position++;
			}
		index>>=1;
		if (index==0)
			{
			index=1<<7;
			nouvPos++;
			}
		}

	nouvPos=0;
	index=1<<7;
	bit=1<<15;
	while (nouvPos<65)
		{
		if (nouvCode[nouvPos]&index)
			{
			echantillon |= bit;
			}
		else
			{
			echantillon &= ~bit;
			}
		index>>=1;
		if (index==0)
			{
			index=1<<7;
			nouvPos++;
			}
		bit>>=1;
		if (bit==0)
			{
			bit=1<<15;
			if (echantillon==0) break;
			}
		}

	if (nouvPos<65)
		{
		while (nouvPos<65)
			{
			nouvCode[nouvPos]=0;
			nouvPos++;
			}
		}

	position=0;
	while (position<65)
		{
		position++;
		}
	return nouvCode;
	}

void enregistre_code(unsigned char *code,char *commande_assignee)
	{
	FILE *fichier;

	fichier=fopen("liste_codes.data","a+");

	fwrite(code,1,64,fichier);
	fputc(' ',fichier);
	fprintf(fichier,"%s\n",commande_assignee);

	fclose(fichier);
	}

char * cherche_code(unsigned char *code)
	{
	FILE *fichier;
	unsigned char *codeLu;
	char *commande;
	int trouve=0;

	codeLu=(unsigned char *)malloc(65*sizeof(unsigned char));
	commande=(char *)malloc(101*sizeof(char));

	fichier=fopen("liste_codes.data","r");
	if (fichier==NULL)
		{
		printf("aucun code enregistr! (fichier inexistant)\n");
		exit(-1);
		}

	do
		{
		fread(codeLu,1,64,fichier);
		fscanf(fichier," %[^\n]\n",commande);

		if (!memcmp(code,codeLu,64))
			{
			trouve=1;
			break;
			}
		}
	while (!feof(fichier));

	if (!trouve)
		{
		fclose(fichier);
		return NULL;
		}
	else
		{
		fclose(fichier);
		return commande;
		}
	}

int supprime_code(unsigned char *code,char *commande_assignee)
	{
	FILE *fichier;
	unsigned char *codeLu;
	unsigned char *fichierCodes;
	char *commande;
	int taille;
	int trouve=0;
	fpos_t positionInit,positionFin,positionTemp;

	codeLu=(unsigned char *)malloc(65*sizeof(unsigned char));
	commande=(char *)malloc(101*sizeof(char));
	fichierCodes=NULL;

	fichier=fopen("liste_codes.data","r+");
	if (fichier==NULL)
		{
		printf("aucun code enregistr! (fichier inexistant)\n");
		exit(-1);
		}

	do
		{
		fgetpos(fichier,&positionInit);
		fread(codeLu,1,64,fichier);
		fscanf(fichier," %[^\n]\n",commande);
		if (commande_assignee!=NULL)
			{
			if (!strcmp(commande,commande_assignee))
				{
				trouve=1;
				break;
				}
			}
		else
			{
		if (!memcmp(code,codeLu,64))
				{
				trouve=1;
				break;
				}
			}
		}
	while (!feof(fichier));

	if (!trouve)
		{
		fclose(fichier);
		return -1;
		}
	else
		{
		fgetpos(fichier,&positionFin);
		taille=0;
		rewind(fichier);
		while (!feof(fichier))
			{
			fgetpos(fichier,&positionTemp);
			if (positionTemp!=positionInit)
				{
				fichierCodes=(unsigned char *)realloc(fichierCodes,(taille+1)*sizeof(unsigned char));
				fichierCodes[taille]=fgetc(fichier);
				taille++;
				}
			else fsetpos(fichier,&positionFin);
			}
		fclose(fichier);
		fichier=fopen("liste_codes.data","w");
		fwrite(fichierCodes,1,taille-1,fichier);
		fclose(fichier);
		return 0;
		}
	}

int main(int argc,char *argv[])
	{
	unsigned char *code;
	char *commande;
//	char *chaineChiffres;
	int fd;
	int i;
	int processus;
	int chiffres;
	char c;

	fd=ouverturePort(NON_BLOQUANT);
	if (fd==0)
		{
		printf("Impossible d'ouvrir port COM2\nLe logiciel doit etre install en root\n");
		exit(-1);
		}
	i=0;
	do
		{
		read(fd,&c,1);
		i++;
		}
	while (i<10000);

//	change_to_bloquant(fd);
//	sleep(1);
/*	fd=ouverturePort(NON_BLOQUANT);
	if (fd==0)
		{
		printf("Impossible d'ouvrir port COM2\nLe logiciel doit etre install en root\n");
		exit(-1);
		}
	i=0;
	do
		{
		}
	while (read(fd,&c,1)!=-1);

	fermeturePort(fd);*/
	code=(unsigned char*)malloc(65*sizeof(unsigned char));
	commande=(char*)malloc(101*sizeof(char));
	commande[0]=0;
//	chaineChiffres=(char*)malloc(51*sizeof(char));
//	chaineChiffres[0]=0;

	chiffres=0;

	if (argc<2)
		{
		printf("\n\033[31;1mCe logiciel sert a commander votre P.C. via le port srie\nUsage: ./recepteur_IR <action> [\"parametre\"]\033[0m\n\n");
		printf("Liste des actions:\n\najouter <parametre>: permet d'ajouter un nouveau code infrarouge. Exemple: recepteur_IR ajouter \"xmms -p &\"\nVous pouvez egalement mettre recepteur_IR -a debug \"xmms -p &\" pour dbuguer\n\n");
		printf("supprimer [parametre], o le parametre est le nom de la commande. Si vous ne precisez pas de parametre, ce sera un code de la telecommande\n\n");
		printf("background [parametre]: lance le logiciel en arrire plan (des qu'il y a quelque chose sur le port, l'action correspondantes est execute). Le parametre possible est debug.\n\n");
		printf("test: execute la reception d'un code (scrute le port srie 32 fois, execute la commande si elle existe, et affiche diverses informations)\n\n");
		exit (-1);
		}

	if (strcasecmp(argv[1],"ajouter")==0 || strcasecmp(argv[1],"-a")==0)
		{
		if (argc>=3)
			{
			fd=ouverturePort(BLOQUANT);
			if (fd==0)
				{
				printf("Impossible d'ouvrir port COM2\nLe logiciel doit etre install en root\n");
				exit(-1);
				}
			i=0;
			if (argc>3 && strcmp(argv[2],"debug")==0)
				{
				while (i<32)
					{
					printf("\noctet recu n%d ",i);
					fflush(stdout);
					code[i]=lectureCaractere(fd);
					printbin(code[i]);
					i++;
					}
				enregistre_code(analyse_code(code),argv[3]);
				}
			else
				{
				while (i<32)
					{
					code[i]=lectureCaractere(fd);
					i++;
					}
				enregistre_code(analyse_code(code),argv[2]);
				}
			printf("\nCode ajout!\n");
			}
		else
			{
			printf("Il manque la commande  assigner au code infra rouge. Par exemple ./recepteur_IR ajouter halt (pour arreter le P.C.)\n");
			exit (-1);
			}
		}
	else if (strcasecmp(argv[1],"supprimer")==0 || strcasecmp(argv[1],"-s")==0 || strcasecmp(argv[1],"-d")==0)
		{
		if (argc<3)
			{
			fd=ouverturePort(BLOQUANT);
			if (fd==0)
				{
				printf("Impossible d'ouvrir port COM2\nLe logiciel doit etre install en root\n");
				exit(-1);
				}
			i=0;
			while (i<32)
				{
				code[i]=lectureCaractere(fd);
				i++;
				}
			if (supprime_code(analyse_code(code),NULL)) printf("le code  supprimer n'a pas ete trouv\n");
			else printf("Le code  supprimer a ete trouv et supprim\n");
			}
		else
			{
			if (supprime_code(NULL,argv[2])) printf("le code  supprimer n'a pas ete trouv\n");
			else printf("Le code  supprimer a ete trouv et supprim\n");
			}
		}
	else if (strcasecmp(argv[1],"background")==0 || strcasecmp(argv[1],"-b")==0)
		{
		processus=fork();
		if (processus > 0)
			{
			exit (0);
			}
		else if (processus == 0)
			{
			fd=ouverturePort(BLOQUANT);
			if (fd==0)
				{
				printf("Impossible d'ouvrir port COM2\nLe logiciel doit etre install en root\n");
				exit(-1);
				}
			while(1)
				{
				bzero(code,65);
				i=0;
				if (argc>=3 && strcmp(argv[2],"debug")==0)
					{
					while (i<32)
						{
						printf("\noctet recu n%d ",i);
						fflush(stdout);
						code[i]=lectureCaractere(fd);
						printbin(code[i]);
						i++;
						}
					commande=cherche_code(analyse_code(code));
					if (commande!=NULL)
						{
						printf("\n\a\a\acorrespondance: \033[31;1m%s\033[0m\n",commande);

						i=0;
						while (i<strlen(commande)-1)
							{
							if (strncmp(commande+i,"%d",2)==0)
								{
								if (chiffres>0)
									{
									char *temp;
									temp=(char *)malloc(101*sizeof(char));
									strcpy(temp,commande);
									sprintf(commande,temp,chiffres);
									free(temp);
									}
								else
									{
									if (commande[strlen(commande)-1]=='&') strcpy(commande+i," &");
									else commande[i]=0;
									}
								break;
								}
							i++;
							}

						if (strlen(commande)==1 && commande[0]>=48 && commande[0]<=57)	//est-ce un chiffre?
							{
							if (chiffres<0) chiffres=0;
							chiffres*=10;
							chiffres+=commande[0]-48;
							printf("chiffres vaut maintenant: %d\n",chiffres);
							continue;
							}
						else chiffres=-1;
						printf("On va lancer: %s\n",commande);
						system(commande);
						}
					else printf("\n\033[31;1maucune correspondance trouve\033[0m\n");
					}
				else
					{
					while (i<32)
						{
						code[i]=lectureCaractere(fd);
						i++;
						}
					commande=cherche_code(analyse_code(code));
					if (commande!=NULL)
						{
						printf("\a\a\a");
						fflush(stdout);
						i=0;
						while (i<strlen(commande)-1)
							{
							if (strncmp(commande+i,"%d",2)==0)
								{
								if (chiffres>0)
									{
									char *temp;
									temp=(char *)malloc(101*sizeof(char));
									strcpy(temp,commande);
									sprintf(commande,temp,chiffres);
									free(temp);
									}
								else
									{
									if (commande[strlen(commande)-1]=='&') strcpy(commande+i," &");
									else commande[i]=0;
									}
								break;
								}
							i++;
							}

						if (strlen(commande)==1 && commande[0]>=48 && commande[0]<=57)	//est-ce un chiffre?
							{
							if (chiffres<0) chiffres=0;
							chiffres*=10;
							chiffres+=commande[0]-48;
							continue;
							}
						else chiffres=-1;
						system(commande);
						}
					}
				}
			fermeturePort(fd);
			}
		else
			{
			printf("Erreur dans la mise en arriere plan\n");
			}
		}
	else if (strcasecmp(argv[1],"test")==0 || strcasecmp(argv[1],"-t")==0)
		{
		fd=ouverturePort(BLOQUANT);
		if (fd==0)
			{
			printf("Impossible d'ouvrir port COM2\nLe logiciel doit etre install en root\n");
			exit(-1);
			}
		bzero(code,65);
		i=0;
		while (i<32)
			{
			printf("\noctet recu n%d ",i);
			fflush(stdout);
			code[i]=lectureCaractere(fd);
			printbin(code[i]);
			i++;
			}
		if (cherche_code(analyse_code(code))!=NULL)
			{
			printf("\ncorrespondance: \033[31;1m%s\033[0m\n",cherche_code(analyse_code(code)));
			system(cherche_code(analyse_code(code)));
			}
		else printf("\n\033[31;1maucune correspondance trouve\033[0m\n");
		fermeturePort(fd);
		}
	else
		{
		printf("Parametre incorrect. Lancez ./recepteur_IR pour plus d'informations\n");
		exit (-1);
		}

	return 0;
	}
